import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.image.*;
import java.net.*;



public class Client
{
    private static int getFullColor(int byteColor)
    {
	int r=byteColor&0xe0;
	int g=(byteColor&0x1c)<<3;
	int b=(byteColor&0x03)<<6;
	
	r=g=b=byteColor;
	return (r<<16)|(g<<8)|b;
    }

    public static void main(String args[]) throws Exception
    {
	int height=Integer.parseInt(args[2]);
	int width=Integer.parseInt(args[3]);

	Screen scn = new Screen(width+20,height+20,BufferedImage.TYPE_INT_RGB);
	JFrame app = new JFrame("Jaycam - RTVS");

	InetAddress group = InetAddress.getByName(args[0]);
	MulticastSocket s = new MulticastSocket(Integer.parseInt(args[1]));
	s.joinGroup(group);
	app.setSize(width+20,height+40);
	app.getContentPane().add(scn);
	WindowListener l = new WindowAdapter()
	    {
		public void windowClosing(WindowEvent e)
		{
		    System.exit(0);
		}
	    };
	
	app.addWindowListener(l);
	app.show();
	
	int len;
	boolean temp=true;
	int frameNum=0;
	long start=0,end=0;
	while(true)
	{
	    byte[] buf = new byte[2000];
	    DatagramPacket recv = new DatagramPacket(buf, buf.length);

	    s.receive(recv);
	    len=recv.getLength();

	    int nrows=1;
	    int ncols=160;
	    int row=MyUtil.unsigned(buf[1])-1;
	    //   System.out.println(row);
	    //	    if (row==120)
	    //		row=119;
	    //get packet data
	    for(int r=0;r<nrows;r++) {
	    	for(int c=0;c<ncols;c++) {
		    try {
			synchronized(scn.img){
// 			    int val=getFullColor(MyUtil.unsigned(buf[r*ncols+c+2]));
// 			    int c2=c<<1;
// 			    int r2=(row+r)<<1;
// 			    scn.img.setRGB(c2,r2,val);
// 			    scn.img.setRGB(c2,r2+1,val);
// 			    scn.img.setRGB(c2+1,r2,val);
// 			    scn.img.setRGB(c2+1,r2+1,val);


			    scn.img.setRGB(c,row+r,
			    		   getFullColor(MyUtil.unsigned(buf[r*ncols+c+2])));
			}
		    } catch(Exception e) {
			//	System.out.println(row+r);
			//			System.err.println(e);
		    }
		}
		//		scn.reDrawLine(r);

	    }
	    if (row==0)
		scn.repaint();
	}
	
    }
}
